// BoundaryTag.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "BoundaryBlock.h"
#include "string.h"
#include "stdio.h"

struct MyClassBase {
	char name[16];
	MyClassBase(const char* n) {
		memset(name, 0 ,sizeof(name));
		memcpy(name, n, strlen(n) + 1);
	}
};

struct MyClassA : MyClassBase {
	unsigned val;
	MyClassA() : MyClassBase("MyClassA"), val(0xAA) {}
};

struct MyClassB : MyClassBase {
	unsigned val1, val2;
	MyClassB() : MyClassBase("MyClassB"), val1(0xBB), val2(0x3BB3) {}
};

struct MyClassC : MyClassBase {
	unsigned val1, val2, val3;
	MyClassC() : MyClassBase("MyClassC"), val1(0xCC), val2(0x4CC4), val3(0x4CCCC4) {}
};

struct MyClassD : MyClassBase {
	unsigned val1, val2, val3, val4;
	MyClassD() : MyClassBase("MyClassD"), val1(0xDD), val2(0x5DD5), val3(0x5DDDD5), val4(0x5DDDDDD5) {}
};

struct MyClassMarge : MyClassBase {
	MyClassMarge() : MyClassBase("MyClassMarge") {}
};

char memory[1024];
unsigned lastPos = 0;

// ubN쐬
template<class T>
void* createBlock(T &obj) {
	Dix::BoundaryBlock<> *b1 = new(memory + lastPos) Dix::BoundaryBlock<>(sizeof(T));
	lastPos += b1->getBlockSize();
	void *p = b1->getMemory();
	return new(p) T();
}

int main()
{
	// Block4쐬
	printf("---- Block4쐬 ----\n");
	createBlock(MyClassA());
	createBlock(MyClassB());
	createBlock(MyClassC());
	createBlock(MyClassD());

	// ubN̍ŏ猟Ă݂悤
	printf("\n---- Ce[g ----\n");
	Dix::BoundaryBlock<> *block = (Dix::BoundaryBlock<>*)memory;
	for (unsigned i = 0; i < 4; i++) {
		MyClassBase* pObj = (MyClassBase*)block->getMemory();
		printf("%d: %s(%d)\n", i, pObj->name, block->getMemorySize());
		block = block->next();
	}

	// ߂Ă݂悤
	printf("\n---- tCe[g ----\n");
	block = block->prev();
	for (unsigned i = 4; i != 0; i--) {
		MyClassBase* pObj = (MyClassBase*)block->getMemory();
		printf("%d: %s(%d)\n", i-1, pObj->name, block->getMemorySize());
		block = block->prev();
	}

	// 2Ԗڂ̃ubN3ԖڂƂ}[W悤
	printf("\n---- B2-B3 }[W ----\n");
	block = block->next(); // 2Ԗڂ
	block->marge();
	new(block->getMemory()) MyClassMarge();

	// }[W̃ubNŏ猟Ă݂悤
	printf("\n---- Ce[g ----\n");
	block = (Dix::BoundaryBlock<>*)memory;
	for (unsigned i = 0; i < 3; i++) {
		MyClassBase* pObj = (MyClassBase*)block->getMemory();
		printf("%d: %s(%d)\n", i, pObj->name, block->getMemorySize());
		block = block->next();
	}

	// ߂Ă݂悤
	printf("\n---- tCe[g ----\n");
	block = block->prev();
	for (unsigned i = 3; i != 0; i--) {
		MyClassBase* pObj = (MyClassBase*)block->getMemory();
		printf("%d: %s(%d)\n", i - 1, pObj->name, block->getMemorySize());
		block = block->prev();
	}

	// 2Ԗڂ̃ubN̕s
	printf("\n---- }[WubN̕s ----\n");
	Dix::BoundaryBlock<> *b2 = block->next(); // 2Ԗڂ
	if (!b2->enableSplit(sizeof(MyClassB) + 100))
		printf("sij\n");

	// 2Ԗڂ̃ubN𕪊܂
	printf("\n---- }[WubN𕪊 ----\n");
	b2 = block->next(); // 2Ԗڂ
	Dix::BoundaryBlock<> *b3 = b2->split(sizeof(MyClassB));
	new(b2->getMemory()) MyClassB();
	new(b3->getMemory()) MyClassC();

	// ubN̍ŏ猟Ă݂悤
	printf("\n---- Ce[g ----\n");
	block = (Dix::BoundaryBlock<>*)memory;
	for (unsigned i = 0; i < 4; i++) {
		MyClassBase* pObj = (MyClassBase*)block->getMemory();
		printf("%d: %s(%d)\n", i, pObj->name, block->getMemorySize());
		block = block->next();
	}

	// ߂Ă݂悤
	printf("\n---- tCe[g ----\n");
	block = block->prev();
	for (unsigned i = 4; i != 0; i--) {
		MyClassBase* pObj = (MyClassBase*)block->getMemory();
		printf("%d: %s(%d)\n", i - 1, pObj->name, block->getMemorySize());
		block = block->prev();
	}

	return 0;
}

